﻿using OpenLiveWriter.Api;
using System;

namespace FilesForOLW
{
    public class FileContentEditor : SmartContentEditor
    {
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.TextBox txtFileName;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.TextBox txtClass;
        private ISmartContentEditorSite EditorSite;
        public FileContentEditor(ISmartContentEditorSite editorSite)
        {
            InitializeComponent();
            EditorSite = editorSite;
            this.txtClass.TextChanged += new EventHandler(txtClass_TextChanged);
            this.txtFileName.TextChanged += new EventHandler(txtFileName_TextChanged);
        }


        void txtFileName_TextChanged(object sender, EventArgs e)
        {
            ISmartContent content = SelectedContent;
            if (content == null) return;
            Settings setting = new Settings(content);
            setting.FileName = txtFileName.Text;
            OnContentEdited();

        }

        void txtClass_TextChanged(object sender, EventArgs e)
        {
            ISmartContent content = SelectedContent;
            if (content == null) return;
            Settings setting = new Settings(content);
            setting.ClassName= txtClass.Text;
            OnContentEdited();

        }

        protected override void OnSelectedContentChanged()
        {
            ISmartContent content = SelectedContent;
            
            this.txtClass.TextChanged -= new EventHandler(txtClass_TextChanged);
            this.txtFileName.TextChanged -= new EventHandler(txtFileName_TextChanged);
            Settings setting = new Settings(content);

            txtFileName.Text = setting.FileName;
            txtClass.Text = setting.ClassName;
          
            this.txtClass.TextChanged += new EventHandler(txtClass_TextChanged);
            this.txtFileName.TextChanged += new EventHandler(txtFileName_TextChanged);
            
            base.OnSelectedContentChanged();
        }
        

        private void InitializeComponent()
        {
            this.label1 = new System.Windows.Forms.Label();
            this.txtFileName = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.txtClass = new System.Windows.Forms.TextBox();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(3, 13);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(51, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "Link Text";
            // 
            // txtFileName
            // 
            this.txtFileName.Location = new System.Drawing.Point(6, 29);
            this.txtFileName.Name = "txtFileName";
            this.txtFileName.Size = new System.Drawing.Size(191, 20);
            this.txtFileName.TabIndex = 3;
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(4, 56);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(55, 13);
            this.label2.TabIndex = 4;
            this.label2.Text = "Link Class";
            // 
            // txtClass
            // 
            this.txtClass.Location = new System.Drawing.Point(7, 73);
            this.txtClass.Name = "txtClass";
            this.txtClass.Size = new System.Drawing.Size(190, 20);
            this.txtClass.TabIndex = 5;
            // 
            // FileContentEditor
            // 
            this.Controls.Add(this.txtClass);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.txtFileName);
            this.Controls.Add(this.label1);
            this.Name = "FileContentEditor";
            this.ResumeLayout(false);
            this.PerformLayout();

        }
    }
}
